//C++
//
// Generated by cxsetup.  Do not edit manually.

#include <funcWrappers.h>
#include <functionMap.h>
#include <xsTypes.h>
#include <cfortran.h>

void cppModelWrapper(const double* energy, int nFlux, const double* params, 
        int spectrumNumber, double* flux, double* fluxError, const char* initStr, 
        int nPar, void (*cppFunc)(const RealArray&, const RealArray&,
        int, RealArray&, RealArray&, const string&));

void fcppModelWrapper(const float* energy, int nFlux, const float* params, 
        int spectrumNumber, float* flux, float* fluxError,  
        int nPar, void (*cppFunc)(const RealArray&, const RealArray&,
	int, RealArray&, RealArray&, const string&));


void cppModelWrapper(const double* energy, int nFlux, const double* params, 
        int spectrumNumber, double* flux, double* fluxError, const char* initStr, 
        int nPar, void (*cppFunc)(const RealArray&, const RealArray&,
        int, RealArray&, RealArray&, const string&))
{
   // Assumes energy points to arrays of size nFlux+1, flux and fluxError
   // point to arrays of size nFlux (though they need not be initialized),
   // and params points to an array of size nPar.
   RealArray energy_C(energy, (size_t)nFlux+1);
   RealArray params_C(params, nPar);
   RealArray flux_C(flux, (size_t)nFlux);
   RealArray fluxError_C(fluxError, (size_t)nFlux);
   string cppStr;
   if(initStr && strlen(initStr))
      cppStr = initStr;
   (*cppFunc)(energy_C, params_C, spectrumNumber, flux_C, fluxError_C, cppStr);
   for (int i=0; i<nFlux; ++i)
   {
      flux[i] = flux_C[i];
   }
   if (fluxError_C.size())
   {
      for (int i=0; i<nFlux; ++i)
      {
         fluxError[i] = fluxError_C[i];
      }
   }
} 

void fcppModelWrapper(const float* energy, int nFlux, const float* params, 
        int spectrumNumber, float* flux, float* fluxError, 
        int nPar, void (*cppFunc)(const RealArray&, const RealArray&,
        int, RealArray&, RealArray&, const string&))
{
   // Assumes energy points to arrays of size nFlux+1, flux and fluxError
   // point to arrays of size nFlux (though they need not be initialized),
   // and params points to an array of size nPar.
   RealArray energy_C(0.0, (size_t)nFlux+1);
   RealArray params_C(0.0, nPar);
   RealArray flux_C(0.0, (size_t)nFlux);
   RealArray fluxError_C(0.0, (size_t)nFlux);
   string cppStr;

   for (int i=0; i<nFlux+1; ++i)
   {
      energy_C[i] = (double)energy[i];
   }
   for (int i=0; i<nPar; ++i)
   {
      params_C[i] = (double)params[i];
   }
   for (int i=0; i<nFlux; ++i)
   {
      flux_C[i] = (double)flux[i];
   }
   if (fluxError)
   {
      for (int i=0; i<nFlux; ++i)
      {
         fluxError_C[i] = (double)fluxError[i];
      }
   }


   (*cppFunc)(energy_C, params_C, spectrumNumber, flux_C, fluxError_C, cppStr);

   for (int i=0; i<nFlux; ++i)
   {
      flux[i] = (float)flux_C[i];
   }
   if (fluxError_C.size())
   {
      for (int i=0; i<nFlux; ++i)
      {
         fluxError[i] = (float)fluxError_C[i];
      }
   }
} 

void f_xsbexrav(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsbexrav,XSBEXRAV,xsbexrav,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsbexrav,DXSBEXRAV,dxsbexrav,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsbexrav(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 9;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsbexrav);
}

void C_xsbexrav(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 9;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsbexrav);
}

void f_xsbexriv(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsbexriv,XSBEXRIV,xsbexriv,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsbexriv,DXSBEXRIV,dxsbexriv,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsbexriv(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 11;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsbexriv);
}

void C_xsbexriv(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 11;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsbexriv);
}

void f_brokenPowerLaw(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_brokenPowerLaw,XSBPLW,xsbplw,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_brokenPowerLaw,DXSBPLW,dxsbplw,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_brokenPowerLaw(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 3;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, brokenPowerLaw);
}

void C_brokenPowerLaw(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 3;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, brokenPowerLaw);
}

void f_broken2PowerLaw(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_broken2PowerLaw,XSB2PL,xsb2pl,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_broken2PowerLaw,DXSB2PL,dxsb2pl,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_broken2PowerLaw(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, broken2PowerLaw);
}

void C_broken2PowerLaw(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, broken2PowerLaw);
}

void f_cemVMekal(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_cemVMekal,CEVMKL,cevmkl,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_cemVMekal,DCEVMKL,dcevmkl,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_cemVMekal(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 19;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, cemVMekal);
}

void C_cemVMekal(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 19;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, cemVMekal);
}

void f_xscflw(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xscflw,XSCFLW,xscflw,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xscflw,DXSCFLW,dxscflw,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xscflw(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xscflw);
}

void C_xscflw(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xscflw);
}

void f_xscompps(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xscompps,XSCOMPPS,xscompps,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xscompps,DXSCOMPPS,dxscompps,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xscompps(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 19;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xscompps);
}

void C_xscompps(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 19;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xscompps);
}

void f_cutoffPowerLaw(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_cutoffPowerLaw,XSPLCO,xsplco,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_cutoffPowerLaw,DXSPLCO,dxsplco,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_cutoffPowerLaw(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 2;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, cutoffPowerLaw);
}

void C_cutoffPowerLaw(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 2;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, cutoffPowerLaw);
}

void f_xeq(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xeq,XEQ,xeq,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xeq,DXEQ,dxeq,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xeq(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 3;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xeq);
}

void C_xeq(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 3;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xeq);
}

void f_xnneq(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xnneq,XNNEQ,xnneq,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xnneq,DXNNEQ,dxnneq,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xnneq(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xnneq);
}

void C_xnneq(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xnneq);
}

void f_kerrbb(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_kerrbb,KERRBB,kerrbb,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_kerrbb,DKERRBB,dkerrbb,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_kerrbb(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 9;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, kerrbb);
}

void C_kerrbb(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 9;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, kerrbb);
}

void f_kerrdisk(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_kerrdisk,KERRDISK,kerrdisk,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_kerrdisk,DKERRDISK,dkerrdisk,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_kerrdisk(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 7;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, kerrdisk);
}

void C_kerrdisk(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 7;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, kerrdisk);
}

void f_xslaor(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xslaor,XSLAOR,xslaor,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xslaor,DXSLAOR,dxslaor,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xslaor(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xslaor);
}

void C_xslaor(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xslaor);
}

void f_laor2(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_laor2,LAOR2,laor2,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_laor2,DLAOR2,dlaor2,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_laor2(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 7;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, laor2);
}

void C_laor2(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 7;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, laor2);
}

void f_xsmkcf(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsmkcf,XSMKCF,xsmkcf,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsmkcf,DXSMKCF,dxsmkcf,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsmkcf(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsmkcf);
}

void C_xsmkcf(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsmkcf);
}

void f_xneq(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xneq,XNEQ,xneq,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xneq,DXNEQ,dxneq,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xneq(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 4;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xneq);
}

void C_xneq(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 4;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xneq);
}

void f_xshock(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xshock,XSHOCK,xshock,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xshock,DXSHOCK,dxshock,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xshock(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 6;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xshock);
}

void C_xshock(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 6;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xshock);
}

void f_xsnteea(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsnteea,XSNTEEA,xsnteea,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsnteea,DXSNTEEA,dxsnteea,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsnteea(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 15;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsnteea);
}

void C_xsnteea(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 15;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsnteea);
}

void f_nthcomp(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_nthcomp,NTHCOMP,nthcomp,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_nthcomp,DNTHCOMP,dnthcomp,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_nthcomp(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, nthcomp);
}

void C_nthcomp(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, nthcomp);
}

void f_xspexrav(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xspexrav,XSPEXRAV,xspexrav,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xspexrav,DXSPEXRAV,dxspexrav,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xspexrav(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 7;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xspexrav);
}

void C_xspexrav(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 7;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xspexrav);
}

void f_xspexriv(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xspexriv,XSPEXRIV,xspexriv,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xspexriv,DXSPEXRIV,dxspexriv,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xspexriv(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 9;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xspexriv);
}

void C_xspexriv(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 9;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xspexriv);
}

void f_powerLaw(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_powerLaw,XSPWLW,xspwlw,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_powerLaw,DXSPWLW,dxspwlw,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_powerLaw(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 1;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, powerLaw);
}

void C_powerLaw(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 1;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, powerLaw);
}

void f_xneqs(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xneqs,XNEQS,xneqs,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xneqs,DXNEQS,dxneqs,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xneqs(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xneqs);
}

void C_xneqs(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xneqs);
}

void f_xsedov(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsedov,XSEDOV,xsedov,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsedov,DXSEDOV,dxsedov,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsedov(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsedov);
}

void C_xsedov(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsedov);
}

void f_sirf(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_sirf,SIRF,sirf,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_sirf,DSIRF,dsirf,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_sirf(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 9;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, sirf);
}

void C_sirf(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 9;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, sirf);
}

void f_xseq(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xseq,XSEQ,xseq,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xseq,DXSEQ,dxseq,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xseq(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 14;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xseq);
}

void C_xseq(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 14;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xseq);
}

void f_xsnneq(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsnneq,XSNNEQ,xsnneq,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsnneq,DXSNNEQ,dxsnneq,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsnneq(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 17;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsnneq);
}

void C_xsnneq(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 17;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsnneq);
}

void f_xsvmcf(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsvmcf,XSVMCF,xsvmcf,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsvmcf,DXSVMCF,dxsvmcf,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsvmcf(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 18;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsvmcf);
}

void C_xsvmcf(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 18;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsvmcf);
}

void f_xsneq(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsneq,XSNEQ,xsneq,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsneq,DXSNEQ,dxsneq,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsneq(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 16;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsneq);
}

void C_xsneq(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 16;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsneq);
}

void f_xsshock(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsshock,XSSHOCK,xsshock,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsshock,DXSSHOCK,dxsshock,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsshock(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 18;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsshock);
}

void C_xsshock(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 18;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsshock);
}

void f_xsneqs(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsneqs,XSNEQS,xsneqs,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsneqs,DXSNEQS,dxsneqs,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsneqs(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 17;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsneqs);
}

void C_xsneqs(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 17;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsneqs);
}

void f_xssedov(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xssedov,XSSEDOV,xssedov,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xssedov,DXSSEDOV,dxssedov,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xssedov(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 17;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xssedov);
}

void C_xssedov(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 17;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xssedov);
}

void f_xszgau(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xszgau,XSZGAU,xszgau,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xszgau,DXSZGAU,dxszgau,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xszgau(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 3;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xszgau);
}

void C_xszgau(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 3;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xszgau);
}

void f_zpowerLaw(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_zpowerLaw,XSZPLW,xszplw,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_zpowerLaw,DXSZPLW,dxszplw,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_zpowerLaw(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 2;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, zpowerLaw);
}

void C_zpowerLaw(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 2;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, zpowerLaw);
}

void f_xsabsori(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsabsori,XSABSORI,xsabsori,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsabsori,DXSABSORI,dxsabsori,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsabsori(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 6;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsabsori);
}

void C_xsabsori(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 6;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsabsori);
}

void f_xspwab(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xspwab,XSPWAB,xspwab,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xspwab,DXSPWAB,dxspwab,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xspwab(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 3;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xspwab);
}

void C_xspwab(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 3;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xspwab);
}

void f_superExpCutoff(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_superExpCutoff,SPEXPCUT,spexpcut,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_superExpCutoff,DSPEXPCUT,dspexpcut,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_superExpCutoff(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 2;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, superExpCutoff);
}

void C_superExpCutoff(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 2;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, superExpCutoff);
}

void f_tbabs(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_tbabs,TBABS,tbabs,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_tbabs,DTBABS,dtbabs,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_tbabs(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 1;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, tbabs);
}

void C_tbabs(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 1;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, tbabs);
}

void f_tbgrain(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_tbgrain,TBGRAIN,tbgrain,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_tbgrain,DTBGRAIN,dtbgrain,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_tbgrain(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 6;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, tbgrain);
}

void C_tbgrain(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 6;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, tbgrain);
}

void f_tbvabs(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_tbvabs,TBVABS,tbvabs,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_tbvabs,DTBVABS,dtbvabs,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_tbvabs(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 42;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, tbvabs);
}

void C_tbvabs(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 42;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, tbvabs);
}

void f_ztbabs(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_ztbabs,ZTBABS,ztbabs,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_ztbabs,DZTBABS,dztbabs,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_ztbabs(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 2;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, ztbabs);
}

void C_ztbabs(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 2;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, ztbabs);
}

void f_cflux(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_cflux,CFLUX,cflux,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_cflux,DCFLUX,dcflux,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_cflux(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 3;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, cflux);
}

void C_cflux(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 3;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, cflux);
}

void f_xsgsmt(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xsgsmt,XSGSMT,xsgsmt,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xsgsmt,DXSGSMT,dxsgsmt,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xsgsmt(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 2;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xsgsmt);
}

void C_xsgsmt(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 2;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xsgsmt);
}

void f_ireflct(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_ireflct,IREFLCT,ireflct,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_ireflct,DIREFLCT,direflct,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_ireflct(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 7;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, ireflct);
}

void C_ireflct(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 7;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, ireflct);
}

void f_kdblur(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_kdblur,KDBLUR,kdblur,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_kdblur,DKDBLUR,dkdblur,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_kdblur(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 4;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, kdblur);
}

void C_kdblur(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 4;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, kdblur);
}

void f_kdblur2(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_kdblur2,KDBLUR2,kdblur2,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_kdblur2,DKDBLUR2,dkdblur2,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_kdblur2(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 6;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, kdblur2);
}

void C_kdblur2(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 6;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, kdblur2);
}

void f_spinconv(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_spinconv,SPINCONV,spinconv,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_spinconv,DSPINCONV,dspinconv,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_spinconv(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 7;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, spinconv);
}

void C_spinconv(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 7;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, spinconv);
}

void f_xslsmt(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_xslsmt,XSLSMT,xslsmt,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_xslsmt,DXSLSMT,dxslsmt,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_xslsmt(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 2;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, xslsmt);
}

void C_xslsmt(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 2;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, xslsmt);
}

void f_PartialCovering(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_PartialCovering,PRTCOV,prtcov,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_PartialCovering,DPRTCOV,dprtcov,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_PartialCovering(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 1;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, PartialCovering);
}

void C_PartialCovering(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 1;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, PartialCovering);
}

void f_rdblur(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_rdblur,RDBLUR,rdblur,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_rdblur,DRDBLUR,drdblur,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_rdblur(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 4;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, rdblur);
}

void C_rdblur(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 4;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, rdblur);
}

void f_reflct(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_reflct,REFLCT,reflct,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_reflct,DREFLCT,dreflct,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_reflct(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 5;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, reflct);
}

void C_reflct(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 5;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, reflct);
}

void f_simpl(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_simpl,SIMPL,simpl,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_simpl,DSIMPL,dsimpl,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_simpl(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 3;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, simpl);
}

void C_simpl(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 3;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, simpl);
}

void f_pileup(const float* energy, int nFlux, const float* params,
	     int spectrumNumber, float* flux, float* fluxError);

FCALLSCSUB6(f_pileup,PILEUP,pileup,FLOATV,INT,FLOATV,INT,FLOATV,FLOATV)
FCALLSCSUB7(C_pileup,DPILEUP,dpileup,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,DOUBLEV,STRING)

void f_pileup(const float* energy, int nFlux, const float* params,
        int spectrumNumber, float* flux, float* fluxError)
{
   const size_t nPar = 6;
   fcppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        nPar, pileup);
}

void C_pileup(const double* energy, int nFlux, const double* params,
        int spectrumNumber, double* flux, double* fluxError, const char* initStr)
{
   const size_t nPar = 6;
   cppModelWrapper(energy, nFlux, params, spectrumNumber, flux, fluxError,
        initStr, nPar, pileup);
}

